require 'rails_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to test the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator. If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails. There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.

RSpec.describe '/admin/helper_texts', type: :request do
  # Admin::HelperText. As you add validations to Admin::HelperText, be sure to
  # adjust the attributes here as well.
  let(:valid_attributes) { {tool_class: 'Tools::Qqoqcp', reference: 'what', help_text_fr: 'Blabla texte assistance'} }

  let(:invalid_attributes) { {tool_class: nil} }

  let(:user) { FactoryBot.create(:user) }
  before :each do
    sign_in user
  end

  describe 'GET /index' do
    it 'renders a successful response' do
      Admin::HelperText.create! valid_attributes
      get admin_helper_texts_url
      expect(response).to be_successful
    end
  end

  describe 'GET /show' do
    it 'renders a successful response' do
      admin_helper_text = Admin::HelperText.create! valid_attributes
      get admin_helper_text_url(admin_helper_text)
      expect(response).to be_successful
    end
  end

  describe 'GET /new' do
    it 'renders a successful response' do
      get new_admin_helper_text_url
      expect(response).to be_successful
    end
  end

  describe 'GET /edit' do
    it 'render a successful response' do
      admin_helper_text = Admin::HelperText.create! valid_attributes
      get edit_admin_helper_text_url(admin_helper_text)
      expect(response).to be_successful
    end
  end

  describe 'POST /create' do
    context 'with valid parameters' do
      it 'creates a new Admin::HelperText' do
        expect {
          post admin_helper_texts_url, params: { admin_helper_text: valid_attributes }
        }.to change(Admin::HelperText, :count).by(1)
      end

      it 'redirects to the created admin_helper_text' do
        post admin_helper_texts_url, params: { admin_helper_text: valid_attributes }
        expect(response).to redirect_to(admin_helper_texts_url)
      end
    end

    context 'with invalid parameters' do
      it 'does not create a new Admin::HelperText' do
        expect {
          post admin_helper_texts_url, params: { admin_helper_text: invalid_attributes }
        }.to change(Admin::HelperText, :count).by(0)
      end

      it 'renders a successful response (i.e. to display the new template)' do
        post admin_helper_texts_url, params: { admin_helper_text: invalid_attributes }
        expect(response).to be_successful
      end
    end
  end

  describe 'PATCH /update' do
    context 'with valid parameters' do
      let(:new_attributes) { { help_text_fr: 'New blabla'} }

      it 'updates the requested admin_helper_text' do
        admin_helper_text = Admin::HelperText.create! valid_attributes
        patch admin_helper_text_url(admin_helper_text), params: { admin_helper_text: new_attributes }
        admin_helper_text.reload

        expect(admin_helper_text.help_text_fr).to eq 'New blabla'
      end

      it 'redirects to the admin_helper_text' do
        admin_helper_text = Admin::HelperText.create! valid_attributes
        patch admin_helper_text_url(admin_helper_text), params: { admin_helper_text: new_attributes }
        admin_helper_text.reload
        expect(response).to redirect_to(admin_helper_texts_url)
      end
    end

    context 'with invalid parameters' do
      it 'renders a successful response (i.e. to display the edit template)' do
        admin_helper_text = Admin::HelperText.create! valid_attributes
        patch admin_helper_text_url(admin_helper_text), params: { admin_helper_text: invalid_attributes }
        expect(response).to be_successful
      end
    end
  end

  describe 'DELETE /destroy' do
    it 'destroys the requested admin_helper_text' do
      admin_helper_text = Admin::HelperText.create! valid_attributes
      expect {
        delete admin_helper_text_url(admin_helper_text)
      }.to change(Admin::HelperText, :count).by(-1)
    end

    it 'redirects to the admin_helper_texts list' do
      admin_helper_text = Admin::HelperText.create! valid_attributes
      delete admin_helper_text_url(admin_helper_text)
      expect(response).to redirect_to(admin_helper_texts_url)
    end
  end
end
